import 'package:flutter/services.dart';
import 'package:huawei_push/huawei_push.dart';
import 'package:tim_ui_kit_push_plugin/channel/flutter_push_base_impl.dart';
import 'package:tim_ui_kit_push_plugin/tim_ui_kit_push_plugin.dart';

class HuaweiImpl extends FlutterPushBase{

  /// [Developers should not use this field directly] Get HUAWEI Push Token
  @override
  Future<String?> getToken() async {
    return token;
  }

  /// [Developers should not use this field directly] Initialize HUAWEI Push
  @override
  void init(PushClickAction onClickNotificationFunction) {
    onClickNotification = onClickNotificationFunction;
    initHuaweiNotificationListener();
    initHuaweiTokenStream();
  }

  /// [Developers should not use this field directly] Require HUAWEI Push permission
  @override
  void requirePermission() {
    // TODO: implement requirePermission
  }

  /// [Developers should not use this field directly] Initialize HUAWEI token stream
  Future<void> initHuaweiTokenStream() async {
    print("TUIKitPush | Dart | HUAWEI | init");
    Push.getToken("");
    Push.getTokenStream.listen(_onHuaweiTokenEvent, onError: _onHuaweiTokenError);
  }

  /// [Developers should not use this field directly] Initialize HUAWEI notification listener
  Future<void> initHuaweiNotificationListener() async {
    Push.onNotificationOpenedApp.listen(_onHaweiNotificationOpenedApp);
  }

  /// [Developers should not use this field directly] Deal with click event from notification via HUAWEI
  void _onHaweiNotificationOpenedApp(remoteMessage) {
    print("onHUAWEINotificationOpenedApp: " + remoteMessage["extras"].toString());
    onClickNotification!(remoteMessage["extras"]);
  }

  /// [Developers should not use this field directly] Callback after receving HUAWEI token
  void _onHuaweiTokenEvent(String event) {
    // Requested tokens can be obtained here
    token = event;
    print("HuaweiTokenEvent: " + token);
  }

  /// [Developers should not use this field directly] Callback when failure on require HUAWEI token
  void _onHuaweiTokenError(Object error) {
    PlatformException e = error as PlatformException;
    print("HuaweiTokenErrorEvent: ${e.message}");
  }

  /// [Developers should not use this field directly] Determin whether the device support HUAWEI Push
  @override
  bool isSupport() {
    return true;
  }
  
}